#include "JNISample.h"
#include <windows.h>

JNIEXPORT jint JNICALL Java_JNISample_clipCursor
  (JNIEnv *env, jclass obj, jint left, jint top, jint right, jint bottom)
{
	RECT r;
	
	if (0 < left){
		r.left = left;
		r.top = top;
		r.right = right;
		r.bottom = bottom;
		return ClipCursor(&r);
	} else {
		return ClipCursor(NULL);
	}
}
JNIEXPORT jint JNICALL Java_JNISample_shellExecute2
  (JNIEnv *env, jclass obj, jbyteArray file)
{
	jboolean isCopy;
	//SJISoCg擾
	char* bytes = env->GetByteArrayElements(file, &isCopy);
	long ret = (long)ShellExecute(NULL, "open", bytes, 
		NULL, NULL, SW_SHOWNORMAL);
	
	if (isCopy == JNI_TRUE){
		env->ReleaseByteArrayElements(file, bytes, 0);
	}
	
	return (jint)ret;
}

JNIEXPORT jint JNICALL Java_JNISample_shellExecute
  (JNIEnv *env, jclass obj, jstring file)
{
//	//UTF8Ŏs@
//	jboolean isCopy;
//	const char* utf8_file = env->GetStringUTFChars(file, &isCopy);
//	long ret = (long)ShellExecute(NULL, "open", utf8_file, 
//			NULL, NULL, SW_SHOWNORMAL);
//	if(isCopy == JNI_TRUE){
//		env->ReleaseStringUTFChars(file, utf8_file);
//	}
	
	//C++ŁAShiftJIScharz𓾂B
	//Unicode擾
	jboolean isCopy;
	const jchar* unicode_file = env->GetStringChars(file, &isCopy);

	//񒷂擾
	jsize unicode_length =  env->GetStringLength(file);
	
	//SJISɕϊ
	char sjis_file[1024];	//ő啶
	int sjis_length = WideCharToMultiByte(
			CP_ACP,
			0,
			(PCWSTR)unicode_file,
			unicode_length,
			sjis_file,
			sizeof(sjis_file),
			NULL,
			NULL);
	sjis_file[sjis_length] = 0;	//NULLI[
	
	long ret = (long)ShellExecute(NULL, "open", sjis_file, 
		NULL, NULL, SW_SHOWNORMAL);
	
	if (isCopy == JNI_TRUE){
		env->ReleaseStringChars(file, unicode_file);
	}
	
	return (jint)ret;
	
}
